/* DelftxDownloads Tool (24-3-2017) / Developed by Jesse Nijdam (Videoproduction-02E) for TU Delft - Extension School */
if (TUDrun == null) {
	var TUDrun = 0;
	var TUD_download_Box = [],
		TUD_YouTubeID = [],
		TUD_DownloadID = [],
		TUD_VideoType = [];
	var TUD_location = window.location.href;		
	if (TUD_location.indexOf("profed.tudelft.nl") != -1) {
		$('head').append('<link rel="stylesheet" href="https://delftxdownloads.tudelft.nl/download-tool/data/profed-styles.css" type="text/css" />');
	} else if (TUD_location.indexOf("ocw.tudelft.nl") != -1) {
		$('head').append('<link rel="stylesheet" href="https://delftxdownloads.tudelft.nl/download-tool/OCW/ocw-styles.css" type="text/css" />');
	} else {
		$('head').append('<link rel="stylesheet" href="https://delftxdownloads.tudelft.nl/download-tool/data/edx-styles.css" type="text/css" />');
	}
} else {
	var TUDrun = parseInt(TUDrun) + 1;
}

console.log("TU Delft", "Download tool " + TUDrun + " started");

document.getElementsByClassName('video-download-top')[TUDrun].dataset.number = TUDrun;
document.getElementsByClassName('subtitle-download-top')[TUDrun].dataset.number = TUDrun;
document.getElementsByClassName('other-download-top')[TUDrun].dataset.number = TUDrun;

TUD_download_Box[TUDrun] = document.getElementsByClassName('TUD_box_download')[TUDrun];

TUD_YouTubeID[TUDrun] = TUD_download_Box[TUDrun].getAttribute("data-YoutubeID");
TUD_DownloadID[TUDrun] = TUD_download_Box[TUDrun].getAttribute("data-DownloadID");
TUD_VideoType[TUDrun] = TUD_download_Box[TUDrun].getAttribute("data-VideoType");

/* Check if array = 0 */
	function TUDadd(a, b) {
			return a + b;
		}

	function TUDarrayisNull(arr) {
		for(var i = 0; i < arr.length; i++) {
			if(arr[i] !== 0) {
				return false;
			}
		}

		return true;
	}

/* Open close dropdowns */
	function videoClick(n) {
		var n = n.getAttribute("data-number");
		document.getElementsByClassName("video-download")[n].classList.toggle("tud-open");
		document.getElementsByClassName("subtitle-download")[n].classList.remove("tud-open");
		document.getElementsByClassName("other-download")[n].classList.remove("tud-open");
	}

	function subtitleClick(n) {
		var n = n.getAttribute("data-number");
		document.getElementsByClassName("video-download")[n].classList.remove("tud-open");
		document.getElementsByClassName("subtitle-download")[n].classList.toggle("tud-open");
		document.getElementsByClassName("other-download")[n].classList.remove("tud-open");
	}

	function otherClick(n) {
		var n = n.getAttribute("data-number");
		document.getElementsByClassName("video-download")[n].classList.remove("tud-open");
		document.getElementsByClassName("subtitle-download")[n].classList.remove("tud-open");
		document.getElementsByClassName("other-download")[n].classList.toggle("tud-open");
	}

/* String building */
	var TUD_DownloadLink = "https://delftxdownloads.tudelft.nl/";
    var TUD_YouTube = ["https://www.youtube.com/embed/", TUD_YouTubeID[TUDrun], "?rel=0&autoplay=1"].join("");
    var TUD_Low_Video = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video.360.mp4"].join("");
    var TUD_Medium_Video = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video.720.mp4"].join("");
    var TUD_High_Video = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video", TUD_VideoType[TUDrun]].join("");

	var TUD_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video.srt"].join("");
    var TUD_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript.pdf"].join("");
    var TUD_CZ_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-CZ.srt"].join("");
    var TUD_CZ_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-CZ.pdf"].join("");
    var TUD_HI_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-HI.srt"].join("");
    var TUD_HI_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-HI.pdf"].join("");
    var TUD_NL_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-NL.srt"].join("");
    var TUD_NL_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-NL.pdf"].join("");
    var TUD_DE_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-DE.srt"].join("");
    var TUD_DE_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-DE.pdf"].join("");
    var TUD_FR_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-FR.srt"].join("");
    var TUD_FR_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-FR.pdf"].join("");
    var TUD_IT_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-IT.srt"].join("");
    var TUD_IT_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-IT.pdf"].join("");
    var TUD_ES_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-ES.srt"].join("");
    var TUD_ES_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-ES.pdf"].join("");
    var TUD_GR_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-GR.srt"].join("");
    var TUD_GR_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-GR.pdf"].join("");
    var TUD_LT_SRT = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-video-LT.srt"].join("");
    var TUD_LT_PDF = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-transcript-LT.pdf"].join("");

	var TUD_Slides = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-slides.pdf"].join("");
    var TUD_Podcast = [TUD_DownloadLink, TUD_DownloadID[TUDrun], "-podcast.mp3"].join("");

/* Checking for file existance function */
	function TUD_FileExist(TUD_url) {
		function TUD_createCORSRequest(method, TUD_url){
		  var xhr = new XMLHttpRequest();
		  if ("withCredentials" in xhr){
			xhr.open(method, TUD_url, false);
		  } else if (typeof XDomainRequest != "undefined"){
			xhr = new XDomainRequest();
			xhr.open(method, TUD_url);
		  } else {
			xhr = null;
		  }
		  return xhr;
		}

		var xhr = TUD_createCORSRequest('HEAD', TUD_url);
		xhr.send();

		var TUD_Load_Status = xhr.status;

		if (xhr.status == "404") {
			return false;
		} else {
			return true;
		}
	}

/* Make sure these are identical to ID's of html elements */
	var TUD_ids = ["TUD_High_Video", "TUD_Medium_Video", "TUD_Low_Video", "TUD_SRT", "TUD_PDF", "TUD_CZ_SRT", "TUD_CZ_PDF", "TUD_HI_SRT", "TUD_HI_PDF", "TUD_NL_SRT", "TUD_NL_PDF", "TUD_DE_SRT", "TUD_DE_PDF", "TUD_FR_SRT", "TUD_FR_PDF", "TUD_IT_SRT", "TUD_IT_PDF", "TUD_ES_SRT", "TUD_ES_PDF", "TUD_GR_SRT", "TUD_GR_PDF", "TUD_LT_SRT", "TUD_LT_PDF", "TUD_Slides", "TUD_Podcast"];

	var TUD_ids_d = [];

/* Setting the links or hiding links that aren't found */
	for (i = 0; i < TUD_ids.length; i++) {
		if (eval(TUD_ids[i]) == "#") {
			TUD_ids_d[i] = 0;
			document.getElementsByClassName(TUD_ids[i])[TUDrun].style.display = "none";
		} else {
			var exists = TUD_FileExist(eval(TUD_ids[i]));

			try {
				if (exists) {
					TUD_ids_d[i] = 1;
					document.getElementsByClassName(TUD_ids[i])[TUDrun].children[0].setAttribute("href", eval(TUD_ids[i]));
				} else {
					TUD_ids_d[i] = 0;  
					document.getElementsByClassName(TUD_ids[i])[TUDrun].style.display = "none";
				}
			} catch (NullPointerException) {
				TUD_ids_d[i] = 0;  
				console.log("DelftxDownloadTool " + TUDrun, "Error: Older HTML " + TUD_ids[i] + " not supported");
			}
		}
	}

	if (TUD_YouTubeID != "#" && TUD_YouTubeID != "") {
		document.getElementsByClassName('TUD_YouTube_A')[TUDrun].setAttribute("href", TUD_YouTube);
	} else {
		document.getElementsByClassName('TUD_YouTube')[TUDrun].style.display = "none";
	}

/* Hiding a button if it's empty */
	if (TUDarrayisNull(TUD_ids_d.slice(0, 3))) {
		document.getElementsByClassName('video-download')[TUDrun].style.display = "none";
	}

	if (TUDarrayisNull(TUD_ids_d.slice(3, TUD_ids_d.length - 2))) {
		document.getElementsByClassName('subtitle-download')[TUDrun].style.display = "none";
	}

	if (TUDarrayisNull(TUD_ids_d.slice(Math.max(TUD_ids_d.length - 2)))) {
		document.getElementsByClassName('other-download')[TUDrun].style.display = "none";
	}

/* Show no download text available */
	if (TUDarrayisNull(TUD_ids_d)) {
		document.getElementsByClassName('no-download')[TUDrun].style.display = "inline";
	}

	if ($(".xblock-license")[0]){
		document.getElementsByClassName('TUD_box_download')[TUDrun].style.marginTop = "-4em";
	}

console.log("TU Delft", "Download tool " + TUDrun + " loaded");

$(document).ready(function() {
	var TUDranNumber = document.getElementsByClassName('TUD_box_download').length - 1;
	if (TUDrun === TUDranNumber) {
		TUDrun = null;
		TUDranNumber = null;
	}
});
